// FORDL.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "FORDL.h"
#include "filnam.h"

#include "MainFrm.h"
#include "ChildFrm.h"
#include "FORDLDoc.h"
#include "FORDLView.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern "C" { __declspec (dllimport) 
	void __stdcall BOOTIT ( int * );
}
extern "C" {void GGF(int IOP);}
/////////////////////////////////////////////////////////////////////////////
// CFORDLApp

BEGIN_MESSAGE_MAP(CFORDLApp, CWinApp)
	//{{AFX_MSG_MAP(CFORDLApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_VIEW_FORTRANDLLTEST1, OnViewFortrandlltest1)
	ON_COMMAND(ID_VIEW_COMMONBLOCKDLLTEST, OnViewCommonblockdlltest)
	ON_COMMAND(ID_DLLTEST_WINBOOTTEST, OnDlltestWinboottest)
	ON_COMMAND(ID_DLLTEST_DATATRANSFERTEST, OnDlltestDatatransfertest)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	// Standard print setup command
	ON_COMMAND(ID_FILE_PRINT_SETUP, CWinApp::OnFilePrintSetup)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFORDLApp construction

CFORDLApp::CFORDLApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CFORDLApp object

CFORDLApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CFORDLApp initialization

BOOL CFORDLApp::InitInstance()
{
	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	LoadStdProfileSettings();  // Load standard INI file options (including MRU)

	// Register the application's document templates.  Document templates
	//  serve as the connection between documents, frame windows and views.

	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_FORDLTYPE,
		RUNTIME_CLASS(CFORDLDoc),
		RUNTIME_CLASS(CChildFrame), // custom MDI child frame
		RUNTIME_CLASS(CFORDLView));
	AddDocTemplate(pDocTemplate);

	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
		return FALSE;
	m_pMainWnd = pMainFrame;

// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);

	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
		return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();

	BOOTOK=FALSE;
	// you may place BOOTIT calls here

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
		// No message handlers
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

// App command to run the dialog
void CFORDLApp::OnAppAbout()
{
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CFORDLApp commands

void CFORDLApp::OnViewFortrandlltest1() 
{
}

void CFORDLApp::OnViewCommonblockdlltest() 
{
}

void CFORDLApp::OnDlltestWinboottest() 
{
	LPCTSTR H2kExeName=AfxGetAppName(); //.EXE is not included
	//int idReturn1 = AfxMessageBox(H2kExeName, MB_OK,0);
	size_t H2kExeNameLen=strlen(H2kExeName);
	char szPath[_MAX_PATH+1];
	char H2kExePath[_MAX_PATH+1];
	VERIFY(::GetModuleFileName(m_hInstance, szPath, _MAX_PATH));
	//szPath includes the full path and file name
	//int idReturn2=AfxMessageBox(szPath, MB_OK,0);
    size_t H2kPathLen=strlen(szPath)-H2kExeNameLen-4;//Excluding "H2kWin.exe"
	//B
	for (int i=strlen(szPath); i>0; i--)
 	{
 	  if ( szPath[i] == '\\' ) 
	  { H2kPathLen=i;
	  i=-2;}
 	}
	//B
	strncpy(H2kExePath,szPath,H2kPathLen);//Now H2kExePath holds the true path
	//B
	for (int iii=0; iii<sizeof(FILNAM.HFILES[5-1]); iii++)
 	{
 	  FILNAM.HFILES[5-1][iii] = ' ';
 	}
 	strncpy(FILNAM.HFILES[5-1], szPath, H2kPathLen );

//In order to  call c GGF(int) function in DLL
	void (*PtrGGFInMain) (int iop);
	PtrGGFInMain=GGF;
	DEVICE.MYFUN1ptr= (int) PtrGGFInMain;
	//Language=ENGLISH;
//		DEVICE.IODFLT[6-1]=0;//=1 for French

	BOOTOK=FALSE;

	BOOTIT ( &BOOTOK );
	
	if (BOOTOK)
		AfxMessageBox("BOOT OK!");
	else
		AfxMessageBox("BOOT FAILED!");

}

void CFORDLApp::OnDlltestDatatransfertest() 
{
	if (!BOOTOK)
	{
		AfxMessageBox("Run WINBOOT Test first");
		return;
	}


}
